//+------------------------------------------------------------------+
//|                                           Chandes Trendscore.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers  1
#property indicator_color1   Red
#property indicator_maximum  1
#property indicator_minimum -1


//
//
//
//
//

extern int     LookBack       = 20;
extern int     LookBackLength = 20;
extern string  timeFrame      = "Current time frame";

//
//
//
//
//

double   TrendBuffer[];
datetime TimeArray[];
int      TimeFrame;
string   IndicatorFileName;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,TrendBuffer);
   SetIndexLabel(0,"Trend score");

   //
   //
   //
   //
   //

   IndicatorFileName = WindowExpertName();
   TimeFrame = stringToTimeFrame(timeFrame);
   IndicatorShortName("Chande\'s trendscore"+TimeFrameToString(TimeFrame)+" ("+LookBack+","+LookBackLength+")");
   return(0);
}
int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   double score;
   int    counted_bars=IndicatorCounted();
   int    limit,i,k;


   if(counted_bars < 0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;

   //
   //
   //
   //
   //
   
   if (TimeFrame != Period())
      {
         limit = MathMax(limit,TimeFrame/Period());
         ArrayCopySeries(TimeArray ,MODE_TIME ,NULL,TimeFrame);
         
         //
         //
         //
         //
         //
         
         for(i=0,int y=0; i<limit; i++)
         {
            if(Time[i]<TimeArray[y]) y++;
            TrendBuffer[i] = iCustom(NULL,TimeFrame,IndicatorFileName,LookBack,LookBackLength,0,y);
         }
         return(0);         
      }
         
   //
   //
   //
   //
   //

   for (i=limit;i>=0;i--)
      {
         for (score=0,k=0; k<LookBackLength; k++)
                  if (Close[i] >= Close[i+k+LookBack])
                        score++;
                  else  score--;                        
         TrendBuffer[i] = score/LookBackLength;
      }            
   return(0);
}


//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   int tf=0;
       tfs = StringTrimLeft(StringTrimRight(StringUpperCase(tfs)));
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
         if (tf<Period()) tf=Period();
  return(tf);
}
string TimeFrameToString(int tf)
{
   string tfs="";
   
   if (tf!=Period())
   {
      switch(tf) {
         case PERIOD_M1:  tfs="M1"  ; break;
         case PERIOD_M5:  tfs="M5"  ; break;
         case PERIOD_M15: tfs="M15" ; break;
         case PERIOD_M30: tfs="M30" ; break;
         case PERIOD_H1:  tfs="H1"  ; break;
         case PERIOD_H4:  tfs="H4"  ; break;
         case PERIOD_D1:  tfs="D1"  ; break;
         case PERIOD_W1:  tfs="W1"  ; break;
         case PERIOD_MN1: tfs="MN";
      }
      tfs = StringConcatenate(" ",tfs);
   }      
   return(tfs);
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      char;
   
   while(lenght >= 0)
      {
         char = StringGetChar(s, lenght);
            if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, lenght, char - 32);
            else 
                 if(char > -33 && char < 0)
                     s = StringSetChar(s, lenght, char + 224);
         lenght--;
      }
   return(s);
}